#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h>
#include "lcd.h"
#include <stdlib.h>
#include <avr/pgmspace.h>
#include <util/delay.h>	

#define F_CPU 16000000UL		// definicia hodinovho kmitotu 16 MHz

char txt1[] = "Volt";           // textove retazce
char txt2[] = "Temp";
char txt3[] = "Rth";
char txt4[] = "RPM";
char txt5[] = "RPM rel.";
char txt6[] = "Voltage";
char txt7[] = "Current";
char txt8[] = "Power";

volatile unsigned int i;        // ukladanie hodnoty z registrov ADC
volatile unsigned int teplota = 0;  // pomocna premenna pri vypocte teploty
volatile unsigned int RPM_memory = 30;  // ukladanie hodnoty komp. registra pri merani otacok
volatile unsigned char memory=0;
volatile unsigned char stranka; // premenna riadiaca zmenu obrazovky
volatile unsigned char a;       // pomocna premenna (perioda merania otacok)
volatile unsigned int b;        // pomocna premenna (perioda zmeny kanalu ADC)
                         
volatile unsigned int pulse;    // zaznamenava periodu tacho signalu
volatile unsigned int start;				// zaznamenanie nstupnej hrany
volatile unsigned int stop;				// zaznamenanie zostupnej hrany
 
volatile unsigned int RPM = 0;      // otacky ventilatora
volatile unsigned char counter;                    // pocitadlo pri merani otacok
volatile unsigned int RTH = 0;      // tepelny odpor
volatile unsigned int RTH1 = 0;     // cela cast
volatile unsigned int RTH2 = 0;     // desatinna cast
volatile   signed int teplota1 = 0;   // cela cast teploty
volatile   signed int teplota2 = 0;   // desatinna cast teploty
volatile   signed int Tambient = 20;   // teplota okolia
volatile unsigned char led_power = 20;// vkon LED diody
volatile unsigned int alarm;    // alarmove hlasenie pre komunikaciu
volatile unsigned int channel [4] = {6,4,3,1};// pole indexov kanalov ADC ktore sa vyuzivaju
volatile   signed int Tstart = 27;// startovacia teplota
volatile unsigned int Tmax = 40;// maximalna teplota
volatile unsigned int pomocna = 0;  // ukladanie hodnot z ADC pre priemerovanie
volatile unsigned int temp_memory = 0;   // ukladanie hodnoty teploty
volatile unsigned int fan_current = 0;   // prud ventilatorom
volatile unsigned int fan_power = 0;     // vykon ventilatora
volatile unsigned int fan_voltage = 0;   // napatia na ventilatore
volatile unsigned int fan_voltage1 = 0;	 // cel as
volatile unsigned int fan_voltage2;	 // desatinn as
volatile unsigned int therm_negative;// napatie na termistore
volatile unsigned int therm_voltage; // napatie na rezistore mostika

volatile unsigned int RPM_relative = 0;  // relativny vykon ventilatora
volatile unsigned int RPMmax = 0;        // maximalne otacky ventilatora
                    
volatile unsigned int  fan_current_max = 0; // maximum prdu ventiltorom
volatile unsigned char change = 0;	// indikcia zmeny hodnot	
volatile unsigned char run = 0;		// indikcia zapnutho ventiltora
volatile unsigned char alarm1 = 0;	// indikcia prekroenia max. teploty
volatile unsigned char alarm2 = 0;	// indikcia zablokovanho vetiltora
volatile unsigned char not_connected = 0; // signalizacia pripojeneho termistora
volatile unsigned char fan_connected = 0; // signalizacia pripojeneho ventilatora
volatile unsigned char data_ready_adc = 0;// indikcia dokonenia A/D prevodov
volatile unsigned char data_ready_rpm = 0;// indikcia dokonenia merania otok	
char string [10];					// pomocny retazec na konvertovanie z typu integer

volatile unsigned char meas = 0;	// spustenie merania otok
volatile unsigned char indexy = 0;  // pomocna premenna (zmena kanalov)
volatile unsigned char samples = 0; // potadlo vzoriek
volatile unsigned char period = 0;	// perioda urovania smernice asovho priebehu teploty
volatile   signed char delta_temperature = 0;	// smernica asovho priebehu teploty
volatile   signed char strmost;	// hodnota urujca max. strmos
volatile unsigned char higher = 0;	// indikcia teploty vyej ako Tstart
volatile unsigned char lower = 0;	// indikcia teploty niej ako Tstart
volatile unsigned char counter2 = 0;// potadlo pre riadenie otok
volatile unsigned int priemer = 0;	// priemerovanie otacok ventilatora
volatile unsigned char first = 1;	// indikacia spustenia prveho merania otacok

void init (void);               // inicializacna funkcia
void zobrazenie_cisla (unsigned int vstup);	// funkcia na vytvorenie reazca z integeru 
void vypocty (void);			// funkcia ktor realizuje vpoty
void registry(void);			// nastavenie registrov
unsigned int measure(void); // meranie otok, vracia hodnotu RPM


// hlavn funkcia
int main(void)
{	
  init();                     	// spustenie inicializanej funkcie prstroja (nastavenie parametrov)

  while (fan_connected ==0)		// pokial sa nezistil fungujci ventiltor stle sa vol inicializan funkcia
   {
        init();
   }

  registry();		// funkcia ktor nastav riadiace registre			
  change = 1;		// nastavenie stavovej premennej aby sa pri prvom behu nekonenej sluky vypsali daje
  
  lcd_gotoxy(0,0);	// prv obrazovka
  lcd_puts(txt2);										
  lcd_gotoxy(0,1);
  lcd_puts(txt3);										
  lcd_gotoxy(0,2);
  lcd_puts(txt4);									

  sei();           // povolenie preruen

 /* nekonen sluka, periodicky v rmci nej prebieha meranie napatia na termistore
  a v prpade spustenia ventiltora aj meranie otok, naptia a prdu ventiltora.
  nasledne sa vola funkcia pre vypoet ich hodnot z nameranch napet. Po zsikani 
  novych hodnot sa vypu na displej. Neustle prebieha testovanie stlaenia tlaidla
  pre zmenu obrazovky (zmysel m len pri zapnutom ventiltore). */ 
  while(1)        
	{
		if (data_ready_adc == 1)	    // testovanie dokonenia prevodov A/D
		{
			{
				ADCSRA &= ~(!0<<ADIE);  // vypnutie preruenia po A/D prevode

				if (run==1)			    // ak je zapnut ventiltor, zmeraj sa otky
					{
						RPM = measure();
					}

				vypocty();				// vol sa funkcia na vpoty
				data_ready_adc = 0;		// nulovanie indikci
				data_ready_rpm = 0;
				change = 1;				// zapnutie indikcie zmeny hodnot
			}
		}


		if (change==1)					// ak bola indikovan zmena hodnot
			{
						change = 0;		// nulovanie indikacie

						switch (stranka)// prepna poda aktulne nastavenej strnky
							{
								case 0: // prv obrazovka
										lcd_gotoxy(8,0);

										if (not_connected == 1)	// ak je odpojen termistor
											{
												lcd_puts("N.C.");
											}
										else
											{	// vpis hodnoty teploty
												zobrazenie_cisla(teplota1);
												lcd_putc(',');
												zobrazenie_cisla(teplota2);
												lcd_putc(0xDF);
												lcd_putc('C');
											}
										
	
										if (alarm1==1)	// ak bola prekroen max. teplota
											{
												lcd_putc('*');
												PORTA ^= 0b00000100;	// blikanie LED
											}
										if (alarm2==1)	// ak je zablokovan ventiltor
											{
												lcd_putc('!');
												PORTA |= (1<<PA2);		// rozsvietenie LED
											}
										if ((alarm1==0) && (alarm2==0))
											{
												lcd_putc(' ');	
												PORTA &=~(!0<<PA2);		// zhasnutie LED
											}

										lcd_gotoxy(8,1);		// vpis hodnoty tepelnho odporu
										zobrazenie_cisla(RTH1);
										lcd_putc(',');
										zobrazenie_cisla(RTH2);
										lcd_puts("Ohm");

										lcd_gotoxy(7,2);		// otky ventiltora
										if (run==1 && RPM==0)	//	ak je zapnut, ale neto sa
											{
												lcd_puts(" Locked");	
											}										
										else if (run==0)		// ak je vypnut
											{
												lcd_gotoxy(7,2);	
												lcd_puts ("        ");
												lcd_gotoxy(8,2);
												lcd_puts("Stand By");
											}														
										else					// ak je zapnuty a ota sa, vpis hodnoty
											{										
												lcd_puts ("         ");
												lcd_gotoxy(8,2);
												zobrazenie_cisla(RPM);
												lcd_puts("00");
											}
								
										lcd_gotoxy(0,3);		// zobrazenie vyaenosti ventiltora
										if (run==1)				// len ak je zapnut
											{
												lcd_puts(txt5);
												lcd_gotoxy(8,3);
												lcd_puts ("        ");
												lcd_gotoxy(9,3);
												if (RPM !=0)
													{
														zobrazenie_cisla(RPM_relative);
														lcd_putc('%');
													}			
											}
										else
											{
												lcd_gotoxy(0,3);
												lcd_puts ("                ");
											}
								
										break;

								case 1:	// druh obrazovka
										lcd_gotoxy(8,0);		// naptie na ventiltore
										zobrazenie_cisla(fan_voltage);
										lcd_puts(" V");

										lcd_gotoxy(8,1);		// prd ventiltorom
										zobrazenie_cisla(fan_current);
										lcd_puts(" mA");

										lcd_gotoxy(8,2);		// prkon ventiltoru
										zobrazenie_cisla(fan_power);
										lcd_puts(" mW");
																			
										break;
							}

				
				ADCSRA |= (1<<ADIE);	// povolenie preruenia po A/D prevode
										
			}
		
		
		if (bit_is_set(PIND,3))         // stlacenia tlacidla OK
            {
               _delay_ms (100);
			   if(run==1)				// ak je zapnut ventiltor
			   	{
				   stranka++;			// prepnutie obrazovky
				   stranka %= 2;

				   lcd_clrscr();		

				   switch (stranka)		// vypsanie lavej polovice obrazovky (pevn)
				   	{
						case 0:			// prv obrazovka
											lcd_gotoxy(0,0);
											lcd_puts(txt2);
										
											lcd_gotoxy(0,1);
											lcd_puts(txt3);
										
											lcd_gotoxy(0,2);
											lcd_puts(txt4);
																	
										
											if (run==1)
												{
													lcd_gotoxy(0,3);
													lcd_puts(txt5);
												}								
											break;

						case 1:			// druh obrazovka
											lcd_gotoxy(0,0);
											lcd_puts(txt6);
										
											lcd_gotoxy(0,1);
											lcd_puts(txt7);
												
											lcd_gotoxy(0,2);
											lcd_puts(txt8);
											break;															
					}	

				   change = 1;	// nastavenie indikacie, aby sa k pevnej asti doplnili seln hodnoty
				   }
				}
			}
}

/* funkcia nastav riadiace registre pre A/D prevodnik a PORTA*/
void registry(void)
{
	// nastavenie prevodnika, zapnutie, prerusenie, automatick spanie, predelika 128 -> Fvz = 125 kHz
  ADCSRA |=	(1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADIE)|(7<<ADPS0);
  
  // referencne napatie -> VCC, kanal 4, zarovnanie doprava
  ADMUX |= (0<<REFS1)|(1<<REFS0)|(0<<ADLAR);
  ADMUX +=  channel[0];	// nastavenie prveho kanalu A/D prevodnika

  DDRA |=  (1<<PA2)|(1<<PA5);   // nastavenie I/O portu A, zdroj napajania pre mostik (PA5), LEDka (PA2)
  PORTA |= (1<<PA5); 
}


/* funkce na mereni otacek ventilatoru (metoda pulse stretching)
 vraci delku ctvrtiny periody jednoho otoceni ventilatoru
 vyjadrenou v hodinove periode citace 1 (64/F_clock) */
unsigned int measure (void)
{
	counter = 3;		// nastavenie poctu vzorkov do premennej
	RPM = 0;			// vynulovanie otacok

	while (counter>0)
		{
			if (first==0)
				{
					TCCR0 = 0;			// vypnuti PWM rizeni 
					PORTB |= (1<<PB3);	// ridici pin se nastavi do konstatni vysoke urovne
				}

			priemer = 0;		// nulovani promenne
			a = 0;				// nulovani pocitadla pro pocet preteceni citace 1

			TCNT1 = 0;			// nulovani citace
			TIMSK |= (1<<TICIE1);	// zapnuti preruseni po detekci hrany
			TIMSK |= (1<<TOIE1);	// zapnuti preruseni po preteceni citace 1

			while(data_ready_rpm==0);	// smycka do ukonceni jednoho mereni			
			data_ready_rpm = 0;		// nulovani priznaku dokonceneho mereni		

			TIMSK &=~(!0<<TICIE1);	// vypnuti preruseni po detekci hrany
		 	TIMSK &= ~(!0<<TOIE1);// vypnuti preruseni po preteceni citace 1	

			if (first==0)
				{
					PORTB &=~(!0<<PB3);		// ridici pin do nizke urovne
					// zapnuti PWM rizeni
					TCCR0 |= (1<<WGM01)|(1<<WGM00)|(1<<COM01)|(0<<COM00)|(2<<CS00);
				}

			if (priemer > 0)
				{
					RPM += (37500/priemer);
				}
			else
				{
					RPM = 0;
				}

			counter--;
		}

	RPM /= 3;						// priemerovanie otacok

	if ((first==0) && (RPM!=0))		// ak sa nejedna o prve meranie a ventilator sa toci
		{
	
			if (RPM > RPM_memory )		// pri rozdiele RPM v abs. hodnote vom ako 1000 sa nov hodnota neulo (chyba)
				{
					if ((RPM - RPM_memory)>10)
						{
							RPM = RPM_memory;
						}
					else
						{
							RPM_memory = RPM;
						}
				}
	
			if (RPM < RPM_memory)
				{
					if ((RPM_memory - RPM)>10)
						{
							RPM = RPM_memory;
						}
					else
						{
							RPM_memory = RPM;
						}
				}
		}
	
	return RPM;		// vraci hodnotu prumerne delky pulzu
}

/* inicializan funkcia prstroja, po potvrdeni uvodnej obrazovky uvatel zad
 vkon LED modulu, zmeraj sa maximlne otky pripojenho ventiltora, alej 
 uvatel zad teplotu v priestore merania, a teplotu ktor m by na chladii.
 V prpade ,e sa nezachyti funkn ventiltor funkcia sa zavol znovu*/
void init (void)          
{
  DDRB |= (1<<PB3);		// spustenie ventiltora naplno
  PORTB|= (1<<PB3);
  
  change = 0;           // nastavenie pomocnej premennej
  
  DDRD = 0;				// nastavenie PORTu D, tlaidl
  PORTD = 0;
  PIND = 0;             

  lcd_init(LCD_DISP_ON);// inicializcia LCD displeja		
  lcd_clrscr();

  
  lcd_gotoxy(3,2);		// uvodna obrazovka
  lcd_puts("  ");
  lcd_gotoxy(3,2);
  lcd_puts("Anton Paus");
  lcd_gotoxy(1,3);
  lcd_puts("&Vlado Pacholik");
  lcd_gotoxy(2,0);
  lcd_puts("Projekt MMIA"); 


  while (change == 0)       // cakanie na stlaenie potvrdenia
        {
          if (bit_is_set(PIND,2))
            {
               _delay_ms (100);
               change = 1;
            }
        }

  lcd_clrscr();              // nastavenie vykonu LED
  lcd_gotoxy(0,0);
  lcd_puts("PowerDissipation");
  lcd_gotoxy(7,2);
  zobrazenie_cisla(led_power);
  lcd_putc('W');
 
  change = 0;                // nastavenie pomocnej premennej

  while (change == 0)        // cakanie na stlacenie potvrdenia
        {
         _delay_ms (100);
         if (bit_is_set(PIND,4))        // stlacenia tlacidla mnus
            {
               _delay_ms (100);
               led_power -= 1;          // dekrementacia hodnoty
               if (led_power == 0)      // limitacia rozsahu
                  {
                   led_power = 255;
                  }
            }
         else if (bit_is_set(PIND,3) )    // stlacenia tlacidla plus
            {
               _delay_ms (100);
               led_power += 1;          //  inkrementacia hodnoty
                if (led_power == 255)   //  limitacia rozsahu
                  {
                   led_power = 1;
                  }
            }

          else if (bit_is_set(PIND,2) )   // stlacenia tlacidla OK
            {
               _delay_ms (500);
               change = 1;
            }            
            
            lcd_gotoxy(7,2);  			  // zobrazenie aktulej hodnoty
			zobrazenie_cisla(led_power);
        }

  change = 0;  

  lcd_clrscr();
  lcd_gotoxy(0,0);
  lcd_puts("RPMmax");     // meranie maximlnych otok
  lcd_gotoxy(0,1);
  lcd_puts("Measurement");
  lcd_gotoxy(3,2);
  lcd_puts("In progress");     

  _delay_ms(1000);
    
  TCCR1B |= (1<<ICNC1)|(1<<ICES1)|(3<<CS10);	// nastavenie registrov pre ta 1
	// zapnutie filtrcie, citlivos na nstupn hranu, predelika
 
  sei();				  // povolenie preruen

  RPMmax = measure();	  // volanie funkcie na meranie otok	
			
  asm("cli");	  		  // zakazanie preruen

  if (RPMmax > 0)         // ak sa ventiltor toil
     {
       lcd_gotoxy(3,2);	  // zobrazenie hodnoty
       lcd_puts("             ");
	   lcd_gotoxy(7,3);
	   zobrazenie_cisla(RPMmax);
	   lcd_puts("00");
       pulse = 0;
       fan_connected = 1; // indikcia pripojenho ventiltora
	   first = 0;
     }
  else					  // ventiltor sa netoil (nepripojen/zl)
     {	
      lcd_gotoxy(3,2);		
	  lcd_puts("Fan not found");     
      fan_connected = 0;
     }


  while (change == 0)       // cakanie na stlaenie potvrdenia
        {
          if (bit_is_set(PIND,2) )
            {
               _delay_ms (100);
               change = 1;
            }
        }

 if (fan_connected == 1)	// alie nastavenia len ak sa naiel ventiltor
 {
  change = 0;

  lcd_clrscr();
  lcd_gotoxy(0,0);
  lcd_puts("Ambient Temp.");     // nastavenie teploty okolia
  lcd_gotoxy(7,2);
  zobrazenie_cisla(Tambient);
  lcd_putc(0xDF);
  lcd_putc('C');

  while (change == 0)           // cakanie na stlacenie potvrdenia
        {
          _delay_ms (100);
         if (bit_is_set(PIND,4) )   // stlacenia tlacidla mnus
            {
               _delay_ms (100);
               Tambient -= 1;       // dekrementacia hodnoty
               if (Tambient == 0)   // limitacia rozsahu
                  {
                   Tambient = 1;
                  }
            }
         else if (bit_is_set(PIND,3) )      // stlacenia tlacidla plus
            {
               _delay_ms (100);
               Tambient += 1;         //  inkrementacia hodnoty
               if (Tambient == 255)  // limitacia rozsahu
                  {
                   Tambient = 1;
                  }
            }
          else if (bit_is_set(PIND,2))    // stlacenia tlacidla OK
            {
               _delay_ms (500);
               change = 1;
            }

            
			  lcd_gotoxy(7,2);		// zobrazenie aktulnej hodnoty
			  zobrazenie_cisla(Tambient);
			  lcd_putc(0xDF);
  			  lcd_putc('C');
			  temp_memory = Tambient;     // ulozenie prvej hodnoty do pamate
        }

  lcd_clrscr();
        
  lcd_gotoxy(0,0);
  lcd_puts("Start Temp.");   // nastavenie startovacej teploty
  lcd_gotoxy(7,2);
  zobrazenie_cisla(Tstart);
  lcd_putc(0xDF);
  lcd_putc('C');

  change = 0;

  while (change == 0)             // cakanie na stlacenie potvrdenia
        {
         _delay_ms (100);
         if (bit_is_set(PIND,4))  // stlacenia tlacidla mnus
            {
               _delay_ms (100);
               Tstart -= 1;        // dekrementacia hodnoty
               if (Tstart == 0)    // limitacia rozsahu
                  {
                   Tstart = 255;
                  }
            }
         else if (bit_is_set(PIND,3) )  // stlacenia tlacidla plus
            {
                _delay_ms (100);
               Tstart += 1;       //  inkrementacia hodnoty
               if (Tstart == 255)// limitacia rozsahu
                  {
                   Tstart = 1;
                  }

             }
          else if (bit_is_set(PIND,2) )  // stlacenia tlacidla ok
            {
               _delay_ms (500);
               change = 1;
            }
            
              
		  lcd_gotoxy(7,2);		// zobrazenie aktulnej hodnoty
		  zobrazenie_cisla(Tstart);
		  lcd_putc(0xDF);
  		  lcd_putc('C');
        } 
   }

   lcd_clrscr();                          
   PORTB &= ~(!0<<PB3); // vypnutie ventiltora
}


/* funkcia prevedie slo typu integer na reazec (string), ktor nsledne
 vype na LCD displej od aktulnej pozcie kurzora */
void zobrazenie_cisla (unsigned int vstup)	
{
	itoa (vstup,string,10);
	lcd_puts(string);
}


/* obsluha preruenia po preteen taa 1, po druhom preteen vrti nulov
 hodnotu premennej priemer, to znamen e sa ventiltor neto */
ISR (TIMER1_OVF_vect)			
{
	a++;
	if(a==2)						// perida pre spustenie merania otok
	{
		priemer = 0;				// ak preteie ta dvakrt znamen to e sa ventiltor neto
		data_ready_rpm = 1;
		a = 0;
	}					
}

/* obsluha preruenia po zachyten hrany na prslunom pine. Na zaiatku je nastaven
 citlivos na nstupn hranu, zaznamen sa hodnota taa a zmen sa citlivos na zostupn
 hranu, po jej zachyten sa zaznamen stav taa a vypota sa rozdiel medzi zachytenmi
 hodnotami -> doba trvania pulzu. Potom sa vrti nastavenie citlivosti na nstupn hranu. */


ISR (TIMER1_CAPT_vect)				// obsluha preruenia po zachyten hrany
{
	if (bit_is_set(TCCR1B,ICES1))
		{
			start = ICR1;			// uloenie stavu taa pri nstupnej hrane
			TCCR1B &= ~(!0<<ICES1);	// zmena citlivosti na zostupn
		}
	else
		{
			stop = ICR1;			// uloenie stavu taa pri zostupnej hrane
			pulse = (stop - start);	// vpoet dky pulzu
			TCCR1B |=  (1<<ICES1);	// zmena citlivosti na nstupn	

			if(data_ready_rpm==0)	// ak sa ak na meranie
				{
					priemer = pulse;// uloenie hodnoty
					a = 0;
				}

			TCNT1 = 0;  
			data_ready_rpm = 1;		// indikcia dokonenia merania
		}
}


/* Obsluha preruenia po dokonen A/D prevodu. Po uplynut peridy sa zaznamen uren poet
 vzoriek (32), prvch 20 vzoriek po prepnut kanlu sa vynech. 32 vzoriek sa nsledne spriemeruje
 a prepne sa kanl, po vmene vetkch kanlov sa nastav prznak, e s merania dokonen */
ISR(ADC_vect)
{
  period++;					 
  		
  if (period == 60)			 // perioda uloenia vzorky
  {	
  	i = ADCW ;               // nacitanie hodnoty z registrov  ADCL a ADCH
    samples++;				 // pocitadlo vzoriek
   	
  if (samples> 20)           // vynechanie prvych 20 hodnot
	  {

			  switch (indexy)// prepinac podla kanalu ADC
			         {
			          case 0:// ulozenie nameranych dat
			                  pomocna += i;
			                  break;
			          case 1:
			                  pomocna += i;
			                  break;
			          case 2:
			                  pomocna += i;
			                  break;
			          case 3:
			                  if(i>fan_current_max)	// ulozi sa len maximalna hodnota (amplituda)
							  	{
									fan_current_max = i;
								}
			                  break;                  
			         }
	  }

 	i = 0;                       // nulovanie pomocnej premennej                                

    if (samples == 52)           // po namerani 32 hodnot
    {
       switch (indexy)           // prepina podla kanalu ADC
         {
            case 0:
                        therm_voltage = (pomocna>>5) ;  // priemerovanie
                        break;
            case 1:
                        therm_negative = (pomocna>>5);  // priemerovanie
                        if (therm_negative > 900)       // ak je napatie na termistore vacsie ako 900, nie je termistor prijeny
                           {
                            not_connected = 1;          // nastavenie signalizacie odpojeneho termistora
                           }
                        else
                           {
                            not_connected = 0;
                           }
                        break;

            case 2:
                        fan_voltage = (pomocna>>5);     // priemerovanie napatia na ventilatore
                        break;
            case 3:
                       // fan_current = (pomocna>>5);     // priemerovanie prudu ventilatorom
                        break;
         }
         
	     pomocna = 0;               // nulovanie pomocnej premennej
	     indexy++ ;                 // zmena kanalu ADC
     
	     if ((indexy>1) && (run==0))// ke nebe ventiltor striedaj sa len kanly 
	        {						// pre meranie naptia na termistore
				indexy = 0;
				data_ready_adc = 1;	// indikcia hotovch meran		
	        }
		 else if (indexy>3)
		 	{
				data_ready_adc = 1;   			
				indexy = 0;
			}
       
	     samples = 0;                          // nulovanie pomocnej premennej
	     ADMUX = 0b01000000 + channel [indexy];// zmena kanalu ADC
	}
	
   period = 0;  
  }	 
}

/* funkcia vypota z nameranch hodnot potrebne veliiny a zaroven 
 ovlda otky ventiltora*/
void vypocty (void)
{
	if ((run==1) && (not_connected == 0))	// ak je vent. zapnut a termistor pripojen
		{
		 fan_voltage *= 46;		// vpoet naptia na ventiltore
         fan_voltage = (fan_voltage>>10);
         fan_voltage1 = fan_voltage/10;	// cel as
         fan_voltage2 = fan_voltage - fan_voltage1*10;	// desatinn as

		 fan_current = fan_current_max*memory;	// vpoet strednej hodnoty prdu ventiltorom, pomocou striedy PWM signlu
         fan_current = (fan_current>>8);   // v mA

         fan_power =  fan_current * fan_voltage;  // vypocet vykonu ventilatora
        }
		

		teplota =  therm_voltage - therm_negative + 500; // posunutie naptia do kladnch hodnot
         
	    if (teplota < 840)			// vypocet teploty pre ni rozsah
            {
               teplota = (teplota - 66)*10;
               teplota /= 11;         
            }
        else						// pre vy rozsah
            {
               teplota = (teplota - 650)*10;
               teplota *= 25;
               teplota = (teplota >> 6);
            }

         teplota += 60;		// kalibran offset           
         teplota1 = teplota/10 ; // cela cast teploty
         teplota2 = teplota - teplota1*10;  // desatinna cast teploty
               
         if ((teplota1 - Tambient)> 0 && (not_connected == 0))    // ak je teplota termistora vyssia ako nastavena teplota okolia a je termistor pripojeny
            {
               RTH = (teplota - (Tambient*10)) / led_power;         // vypocet tepelneho odporu
               RTH1 = RTH /10 ;                                  // cela cast
               RTH2 = RTH - RTH1*10;                             // desatinna cast
            }
         else
            {
               RTH = 0;                                           // ak je teplota termistora nizsia ako nastavena teplota okolia
               RTH1 = 0;
               RTH2 = 0;
            }

         if ((teplota1 > (Tstart-1)) && (not_connected == 0) )   // testovanie teploty, ci treba zapnut ventilator, ak je odpojeny termistor nezapina sa
                 {
                    if (run == 0)                   // zapnutie PWM -> ventilatora
                       {
                        TCCR0 |= (1<<WGM01)|(1<<WGM00)|(1<<COM01)|(0<<COM00)|(2<<CS00); // Fast PWM, nastavenie pri 0, nulovanie pri zhode
                       					            // povolenie prerusenia,predelicka 4
                        DDRB |= (1<<PB3);
                        OCR0 = 20;
						memory = 20;
						delta_temperature = 0;
						strmost = 5;
						higher = 0;
						lower = 0;
                       }
                    alarm1 = 0;		// vypnutie indikaci kritick stavov
					alarm2 = 0;
                    run = 1;        // indikacia zapnutho ventiltora           
                  }
          else if ((teplota1 < (26)) && (not_connected == 0)) // ak teplota klesne pod vypnaciu a je ventiltor zapnut
                  {
                     TCCR0 = 0;          // vypnutie citaca 0, aj povolenia prerusenia
                   	 DDRB &= ~(!0<<PB3);	// vypnutie ventiltora
                     OCR0 = 0;              // nulovanie komp. registra, striedy
                     
					 if (run==1)
					 	{
					 		run = 0;               // signalizacia - ventilator je vypnuty
                     		lcd_gotoxy(0,0);	// prv obrazovka
 						    lcd_puts(txt2);										
						    lcd_gotoxy(0,1);
						    lcd_puts(txt3);										
						    lcd_gotoxy(0,2);
						    lcd_puts(txt4);
							stranka = 0;
						}
					 
					 alarm2 = 0;            // vypnutie alarmu pri zablokovani ventilatora
                     alarm1 = 0;					 
                  } 

          if (run == 1)				// ak je ventiltor zapnut
             {
			  	 	delta_temperature += (teplota - temp_memory); // integrace zmeny teploty
					counter2++;				// potadlo vzorku na integraci
					temp_memory = teplota;	// ulozeni soucasne hodnoty pro vypocet nasledne zmeny teploty

					if (counter2 == 32)		// ukonceni integrace	
						{
							counter2 = 0;	// nulovani pocitadla

							if (teplota > (Tstart*10))	// jestli je teplota vyssi nez zadana
								{
									higher = 1;		// nastavi se prislusne priznaky
									lower = 0;

									if (delta_temperature > (-strmost))	// testovani hodnoty v integratoru
										{					
											OCR0 += 5;		// jestli nevyhovuje zvysi se otacky
															
											if (OCR0 > 249)	// zabraneni preteceni komparacniho registru
												{
													OCR0 = 250;
												}								
										}
								}
							else if (teplota < (Tstart*10))	// jestli je teplota nizsi nez zadana
								{
									higher = 0;		// nastavi se prislusne priznaky
									lower = 1;

									if ((delta_temperature < strmost))	// testovani hodnoty v integratoru
										{
											OCR0 -= 5;		// jestli nevyhovuje snizi se otacky
									
											if (OCR0 < 20)	// zabraneni preteceni komparacniho registru
												{
													OCR0 = 20;
												}								
										}
								}
							else						// jestli je teplota rovna zadana
								{
									if (higher==1)		// testuje se predesli stav
										{
											OCR0 -= 5; 
										}

									if (lower==1)
										{
											OCR0 += 5;
										}								
								}
						}

				                
				  if (teplota1 > Tmax)   // testovanie teploty ci neprekrocila maximum
                    {
                        memory = OCR0;	 // uloenie aktulnej hodnoty OCR0 do pamti
						OCR0 = 255;      // zapnutie maximalnych otacok
                        alarm1 = 1;      // zapnutie signalizacie alarmu pri prehriati
                    }
				  else
				  	{						
						if (alarm1 == 1)
							{
								OCR0 = memory;	// nastavenie hodnoty OCR0 ktor je v pamti
								alarm1 = 0;		// nulovanie indikcie alarmu
							}
					}	

				  if (RPM == 0)			// ak sa ventiltor neto
				  	{
						alarm2 = 1;		// zapnutie alarmu
						memory = OCR0;	// uloenie aktulnej hodnoty OCR0 do pamti
						OCR0 = 255;		// snaha rozbehn ventiltor, max. otky				
					}
				  else
				  	{
						RPM_relative = (RPM*100)/RPMmax; // vpoet vyaenosti ventiltora
						
						if (alarm2 == 1)
							{
								OCR0 = memory;	// nastavenie hodnoty OCR0 ktor je v pamti
								alarm2 = 0;		// nulovanie indikcie alarmu
							}
					}                   
             }		 
}
